// CryptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Crypt.h"
#include "CryptDlg.h"
#include "Crypto.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCryptDlg dialog

CCryptDlg::CCryptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCryptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCryptDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCryptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCryptDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCryptDlg, CDialog)
	//{{AFX_MSG_MAP(CCryptDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCryptDlg message handlers

BOOL CCryptDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCryptDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCryptDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/*************************************/
/*         ifrovac algoritmus      */
/*          (c) David Sehnal         */
/*************************************/

void Crypto::Init(unsigned char key[],int nbytes)
{
	myulong t;

	for (int i = 0; i < nbytes / 4; i++)	
	{
		t.w.byte0 = 0xaf ^ key[4*i];
		t.w.byte1 = 0x1b ^ key[4*i+1];
		t.w.byte2 = 0x5a ^ key[4*i+2];
		t.w.byte3 = 0xf1 ^ key[4*i+3];
	}

	for (i = 0; i < 256; i++)
	{
		table[i] = (tab[i] ^ t.ulong);
	}
}

void Crypto::Encode(unsigned char *input,unsigned char *output,unsigned long size)
{
	myulong t;

	for (unsigned long i = 0; i < size; i++)
	{
		t.ulong = table[i % 255];
		output[i] = (((input[i] ^ t.w.byte2) ^ t.w.byte3) ^ t.w.byte1) ^ t.w.byte0;
	}
}

void Crypto::Decode(unsigned char *input,unsigned char *output,unsigned long size)
{
	myulong t;

	for (unsigned long i = 0; i < size; i++)
	{
		t.ulong = table[i % 255];
		output[i] = (((input[i] ^ t.w.byte0) ^ t.w.byte1) ^ t.w.byte3) ^ t.w.byte2;
	}
}

void CCryptDlg::OnOk() 
{
	unsigned char key[64] = {  // ifrovac kl
		68,201,136,13,
		175,102,88,228,
		166,249,51,108,
		37,40,13,194,
		92,33,94,203,
		57,212,195,236,
		80,186,188,126,
		169,12,34,244,
		90,166,138,97,
		57,121,64,41,
		186,166,236,169,
		61,51,165,177,
		185,141,127,90,
		75,169,87,92,
		94,6,239,79,
		7,76,18,241,
	};

	Crypto c;
	c.Init(key,12);

	unsigned char orig[] = "Testovac text";
	unsigned char crypted[sizeof (orig)+1]; 
	unsigned char decrypted[sizeof (orig)+1];

	crypted[sizeof(orig)] = 0;  // pidn ukonovac nuly etzce
	decrypted[sizeof(orig)] = 0;

	c.Encode(orig,crypted,sizeof(orig));  // zaifrovn etzce
	c.Decode(crypted,decrypted,sizeof(orig));  // deifrovn etzce

	SetDlgItemText(IDC_ORIG,(char*)orig);  // vpis etzc
	SetDlgItemText(IDC_CRYPTED,(char*)crypted);
	SetDlgItemText(IDC_DECRYPTED,(char*)decrypted);
}
