// RSADlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSA.h"
#include "RSADlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRSADlg dialog

CRSADlg::CRSADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSADlg)
	m_dend = 100000;
	m_dstart = 1;
	m_e = 0;
	m_estart = 3;
	m_p = 0;
	m_hereprv = 0;
	m_odkudprv = 0;
	m_q = 0;
	m_d = 0.0;
	m_x = 0;
	m_dd = 0.0;
	m_ze = 0;
	m_pkq = 0.0;
	m_pkq2 = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSADlg)
	DDX_Text(pDX, IDC_DEND, m_dend);
	DDX_Text(pDX, IDC_DSTART, m_dstart);
	DDX_Text(pDX, IDC_E, m_e);
	DDX_Text(pDX, IDC_ESTART, m_estart);
	DDX_Text(pDX, IDC_P, m_p);
	DDX_Text(pDX, IDC_PRV, m_hereprv);
	DDX_Text(pDX, IDC_PRVSTART, m_odkudprv);
	DDV_MinMaxInt(pDX, m_odkudprv, 0, 999999937);
	DDX_Text(pDX, IDC_Q, m_q);
	DDX_Text(pDX, IDC_D, m_d);
	DDX_Text(pDX, IDC_X, m_x);
	DDX_Text(pDX, IDC_DD, m_dd);
	DDX_Text(pDX, IDC_ZE, m_ze);
	DDX_Text(pDX, IDC_PKQ, m_pkq);
	DDX_Text(pDX, IDC_PKQ2, m_pkq2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSADlg, CDialog)
	//{{AFX_MSG_MAP(CRSADlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PRVSEARCH, OnPrvsearch)
	ON_BN_CLICKED(IDC_INSP, OnInsp)
	ON_BN_CLICKED(IDC_INSQ, OnInsq)
	ON_BN_CLICKED(IDC_SEARCHE, OnSearche)
	ON_BN_CLICKED(IDC_SEARCHD, OnSearchd)
	ON_EN_CHANGE(IDC_P, OnChangeP)
	ON_EN_CHANGE(IDC_Q, OnChangeQ)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSADlg message handlers

BOOL CRSADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSADlg::OnPrvsearch() 
{
	UpdateData(TRUE);
	if (m_odkudprv <= 999999937 && m_odkudprv >= 0)
	{
		m_hereprv = GetPrime(m_odkudprv);
		UpdateData(FALSE);
	}
}

__int64 CRSADlg::GetPrime(__int64 start)
{
	__int64 i,Num,Sqrt;
	
	if (start == 0 || start == 1 || start == 2)
		return 2;
	else
	{
		Num = start;
		if (Num % 2 == 0)
			Num++;

		Sqrt = (__int64) sqrt (Num);
		for (i = 3; i <= Sqrt; i += 2)
		{
			if (Num % i == 0)
			{
				i = 1;
				Num += 2;
				Sqrt = (__int64) sqrt (Num);
			}
			else if (i == Sqrt)
				break;
		}
		return Num;
	}
}


BOOL CRSADlg::TestPrc(int cislo)
{
	int i;

	if (cislo == 0 || cislo == 1)
		return FALSE;

	int Sqrt = (int) sqrt (cislo);
	for (i = 2; i <= Sqrt; i++)
	{
		if (cislo % i == 0)
			return FALSE;
	}

	if (Sqrt == 0)
		return FALSE;

	return TRUE;	
}

void CRSADlg::OnInsp() 
{
	UpdateData(TRUE);
	m_p = m_hereprv;
	UpdateData(FALSE);	
}

void CRSADlg::OnInsq() 
{
	UpdateData(TRUE);
	m_q = m_hereprv;
	UpdateData(FALSE);	
}

__int64 CRSADlg::GetNSD(__int64 a,__int64 b)
{
	if (a == 0 || b == 0)
		return 0;

	if (a == 1 || b == 1)
		return 1;

	while (a != b)
	{
		if (a < b)
			b = b-a;

		if (a > b)
			a = a-b;
	}
	return a;
}

void CRSADlg::OnSearche() 
{
	UpdateData(TRUE);

	int x;
	__int64 p,q,k,nsd;

	p = m_p;
	q = m_q;
	k = p*q;

	if (k > 999999999)
	{
		m_pkq = k;
		UpdateData(FALSE);
		MessageBox("Nsobek sel p a q me bt maximln devti-cifern",NULL,MB_OK | MB_ICONINFORMATION);
		return;
	}

	p = m_p-1;
	q = m_q-1;
	k = p*q;
	
	if (TestPrc(m_q) && TestPrc(m_p))
	{
		if (m_q != m_p)
		{
			x = m_estart;
			if (x >= k)
			{
				MessageBox("slo e mus bt men ne (p-1)*(q-1)",NULL,MB_OK | MB_ICONINFORMATION);
				return;
			}
			while (x<k)
			{
				nsd = GetNSD(x,k);
				if (nsd == 1)
				{
					m_e = x;
					m_ze = x;
					m_pkq = m_p*m_q;
					UpdateData(FALSE);
					break;
				}
				if (nsd == 0)
				{
					MessageBox("Pro hledn sla e zadejte slo vt ne 1",NULL,MB_OK | MB_ICONINFORMATION);
					m_e = 3;
					UpdateData(FALSE);
					break;
				}
				x++;
			}
			if (x == k)
			{
				MessageBox("slo e nebylo nalezeno",NULL,MB_OK | MB_ICONINFORMATION);
				return;
			}
		}
		else
			MessageBox("sla p a q musej bt odlin",NULL,MB_OK | MB_ICONINFORMATION);
	}
	else
		MessageBox("sla p a q musej bt prvosla",NULL,MB_OK | MB_ICONINFORMATION);
}

__int64 CRSADlg::GetD(__int64 start,__int64 end,__int64 p,__int64 q,__int64 e)
{
	__int64 x,k = (p-1)*(q-1);

	if (start >= end)
	{
		MessageBox("Poten hodnota pro hledn nsobku sla x mus bt men ne koncov hodnota",NULL,MB_OK | MB_ICONINFORMATION);
		return 0;
	}
	
	if (start == 0) 
		start = 1;
	
	for (x = start; x <= end; x++)
	{
		if ((x*k+1) % e == 0)
		{
			__int64 d = (x*k+1)/e;
			m_x = x;
			return d;
		}
	}
	return 0;
}

void CRSADlg::OnSearchd() 
{
	UpdateData(TRUE);

	if (m_dstart >= m_dend)
	{
		MessageBox("Poten hodnota pro hledn nsobku sla x mus bt men ne koncov hodnota",NULL,MB_OK | MB_ICONINFORMATION);
		return;
	}

	if (m_dstart <= 9999999 && m_dend <= 9999999)
	{
		m_d = GetD(m_dstart,m_dend,m_p,m_q,m_e);
		m_dd = m_d;
		m_pkq2 = m_p*m_q;
		UpdateData(FALSE);

		if (m_d == 0)
			MessageBox("Pro zadanou kombinaci sel nebylo nalezeno slo d",NULL,MB_OK | MB_ICONINFORMATION);
	}
	else
		MessageBox("Zadali jste pli velk sla pro hledn hodnoty sla d",NULL,MB_OK | MB_ICONINFORMATION);
}

void CRSADlg::OnChangeP() 
{
	UpdateData(TRUE);

	if (m_p > 999999999)
	{
		m_p = 0;
		UpdateData(FALSE);
		MessageBox("sla p a q mohou bt maximln devti-cifern",NULL,MB_OK | MB_ICONINFORMATION);
		return;
	}	
}

void CRSADlg::OnChangeQ() 
{
	UpdateData(TRUE);

	if (m_q > 999999999)
	{
		m_q = 0;
		UpdateData(FALSE);
		MessageBox("sla p a q mohou bt maximln devti-cifern",NULL,MB_OK | MB_ICONINFORMATION);
		return;
	}	
}
